a
<!-- card ประกาศเกียรติคุณ -->
<template>
  <q-card flat bordered class="col-12 q-px-lg q-pa-md">
    <q-form ref="myForm">
      <ProfileTable
        :rows="rows"
        :columns="columns"
        :filter="filter"
        :visible-columns="visibleColumns"
        v-model:inputfilter="filter"
        v-model:inputvisible="visibleColumns"
        :add="clickAdd"
        :name="
          profileType == 'employee' ? 'ประกาศลูกจ้างดีเด่น' : 'ประกาศเกียรติคุณ'
        "
        icon="mdi-script-text"
        :statusEdit="statusEdit"
      >
        <template #columns="props">
          <q-tr :props="props">
            <q-td
              v-for="col in props.cols"
              :key="col.name"
              :props="props"
              @click="selectData(props)"
              class="cursor-pointer"
            >
              <div v-if="col.name == 'issueDate'" class="table_ellipsis">
                {{
                  props.row.isDate == true
                    ? date2Thai(props.row.issueDate2)
                    : col.value + 543
                }}
              </div>
              <div
                v-else-if="col.name == 'refCommandDate'"
                class="table_ellipsis"
              >
                {{
                  props.row.refCommandDate
                    ? date2Thai(props.row.refCommandDate)
                    : "-"
                }}
              </div>
              <div v-else class="table_ellipsis">
                {{ col.value ? col.value : "-" }}
              </div>
            </q-td>
            <q-td auto-width>
              <q-btn
                color="info"
                flat
                dense
                round
                size="14px"
                icon="mdi-history"
                @click="clickHistory(props.row)"
              >
                <q-tooltip>ประวัติแก้ไขประกาศเกียรติคุณ</q-tooltip>
              </q-btn>
            </q-td>
          </q-tr>
        </template>
      </ProfileTable>
    </q-form>
  </q-card>
  <!-- popup Edit window-->
  <q-dialog v-model="modal" persistent>
    <q-card style="width: 600px">
      <q-form ref="myForm">
        <DialogHeader
          :tittle="
            profileType == 'employee'
              ? 'ประกาศลูกจ้างดีเด่น'
              : 'ประกาศเกียรติคุณ'
          "
          :close="clickClose"
        />
        <q-separator />
        <q-card-section class="q-p-sm">
          <div class="row col-12 q-col-gutter-x-xs q-col-gutter-y-xs">
            <div class="row col-12 q-gutter-md q-py-sm text-grey-7">
              <q-radio
                v-model="isDate"
                checked-icon="task_alt"
                unchecked-icon="panorama_fish_eye"
                val="false"
                label="ปี"
                dense
                :disable="!edit"
              />
              <q-radio
                v-model="isDate"
                checked-icon="task_alt"
                unchecked-icon="panorama_fish_eye"
                val="true"
                label="วัน/เดือน/ปี"
                dense
                :disable="!edit"
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                v-if="edit && isDate === 'false'"
                outlined
                v-model="inputYear"
                label="ปี"
                mask="####"
                dense
                :error="yearChecked"
                error-message="กรุณากรอกปี"
                :rules="[(val) => !!val || `${'กรุณากรอกปี'}`]"
              />
              <q-input
                v-if="edit && isDate === 'true'"
                outlined
                v-model="inputDate"
                label="วัน/เดือน/ปี"
                mask="##/##/####"
                dense
                :error="dayChecked"
                error-message="กรุณากรอกวัน/เดือน/ปี"
                :rules="[(val) => !!val || `${'กรุณากรอกวัน/เดือน/ปี'}`]"
              />
              <datepicker
                v-if="isDate === 'false' && !edit"
                menu-class-name="modalfix"
                v-model="issueDate"
                :locale="'th'"
                autoApply
                year-picker
                :enableTimePicker="false"
                :readonly="!edit"
                @update:modelValue="clickEditRow"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    :class="getClass(edit)"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="issueDate + 543"
                    hide-bottom-space
                    :label="`${'วันที่ได้รับ'}`"
                    :readonly="!edit"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        :style="
                          edit
                            ? 'color: var(--q-primary)'
                            : 'color: var(--q-grey)'
                        "
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
              <datepicker
                v-else-if="isDate === 'true' && !edit"
                menu-class-name="modalfix"
                :readonly="!edit"
                v-model="issueDate2"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                @update:modelValue="clickEditRow"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    :class="getClass(edit)"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="date2Thai(issueDate2)"
                    :rules="[(val) => !!val || `${'กรุณาเลือกวันที่ได้รับ'}`]"
                    hide-bottom-space
                    :label="`${'วันที่ได้รับ'}`"
                    :readonly="!edit"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        :style="
                          edit
                            ? 'color: var(--q-primary)'
                            : 'color: var(--q-grey)'
                        "
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
            <div class="col-6">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                autogrow
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="issuer"
                :label="`${'ผู้มีอำนาจลงนาม'}`"
                @update:modelValue="clickEditRow"
              />
            </div>
            <div class="col-12">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                autogrow
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="detail"
                :rules="[(val) => !!val || `${'กรุณากรอกรายละเอียด'}`]"
                hide-bottom-space
                :label="`${'รายละเอียด'}`"
                @update:modelValue="clickEditRow"
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="refCommandNo"
                hide-bottom-space
                :label="`${'เลขที่คำสั่ง'}`"
                @update:modelValue="clickEditRow"
              >
                <template v-slot:append>
                  <q-icon
                    name="mdi-file"
                    class="cursor-pointer"
                    @click="resetFilter"
                  />
                </template>
              </q-input>
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                v-if="edit"
                outlined
                v-model="inputDateRef"
                label="เอกสารอ้างอิง (ลงวันที่)"
                mask="##/##/####"
                dense
                :error="dayCheckedRef"
                error-message="กรุณากรอกเอกสารอ้างอิง (ลงวันที่) หรือเว้นว่าง"
              />
              <datepicker
                v-else
                menu-class-name="modalfix"
                :readonly="!edit"
                v-model="refCommandDate"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                @update:modelValue="clickEditRow"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    :class="getClass(edit)"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="
                      refCommandDate == null ? null : date2Thai(refCommandDate)
                    "
                    hide-bottom-space
                    :label="`${'เอกสารอ้างอิง (ลงวันที่)'}`"
                    :readonly="!edit"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        :style="
                          edit
                            ? 'color: var(--q-primary)'
                            : 'color: var(--q-grey)'
                        "
                      >
                      </q-icon>
                    </template>
                    <template v-if="refCommandDate && edit" v-slot:append>
                      <q-icon
                        name="cancel"
                        @click.stop.prevent="refCommandDate = null"
                        class="cursor-pointer"
                      />
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <DialogFooter
          :cancel="clickCancel"
          :edit="clickEdit"
          :save="clickSave"
          :validate="validateData"
          :clickNext="clickNext"
          :clickPrevious="clickPrevious"
          :clickDelete="clickDelete"
          v-model:editvisible="edit"
          v-model:next="next"
          v-model:previous="previous"
          v-model:modalEdit="modalEdit"
        />
      </q-form>
    </q-card>
  </q-dialog>
  <HistoryTable
    :rows="rowsHistory"
    :columns="columnsHistory"
    :filter="filterHistory"
    :visible-columns="visibleColumnsHistory"
    v-model:modal="modalHistory"
    v-model:inputfilter="filterHistory"
    v-model:inputvisible="visibleColumnsHistory"
    v-model:tittle="tittleHistory"
  >
    <template #columns="props">
      <q-tr :props="props">
        <q-td v-for="col in props.cols" :key="col.name" :props="props">
          <div
            v-if="
              col.name == 'issueDate' ||
              col.name == 'createdAt' ||
              col.name == 'refCommandDate'
            "
            class="table_ellipsis"
          >
            {{ col.value ? date2Thai(col.value) : "-" }}
          </div>
          <div v-else class="table_ellipsis">
            {{ col.value ? col.value : "-" }}
          </div>
        </q-td>
      </q-tr>
    </template>
  </HistoryTable>
</template>
<script setup lang="ts">
import { onMounted, ref, watch } from "vue";
import { useRoute } from "vue-router";
import { useCounterMixin } from "@/stores/mixin";
import { useProfileDataStore } from "@/modules/04_registry/store";
import { validateTime } from "@/modules/04_registry/stores/time";

import ProfileTable from "@/modules/04_registry/components/Table.vue";
import DialogHeader from "@/modules/04_registry/components/DialogHeader.vue";
import DialogFooter from "@/modules/04_registry/components/DialogFooter.vue";
import { useQuasar } from "quasar";
import type {
  RequestItemsObject,
  Columns,
} from "@/modules/04_registry/interface/request/Coin";
import type { ResponseObject } from "@/modules/04_registry/interface/response/Coin";
import HistoryTable from "@/components/TableHistory.vue";
import http from "@/plugins/http";
import config from "@/app.config";
import type { QTableProps } from "quasar";

const props = defineProps({
  statusEdit: {
    type: Boolean,
    required: true,
  },
  profileType: {
    type: String,
    required: true,
  },
});

const isDate = ref<string | null>("true");
const $q = useQuasar();
const store = useProfileDataStore();
const { profileData, changeProfileColumns } = store;

const mixin = useCounterMixin();
const {
  date2Thai,
  success,
  dateToISO,
  messageError,
  showLoader,
  hideLoader,
  convertDate,
  convertDateDisplay,
} = mixin;
const route = useRoute();
const id = ref<string>("");
const issuer = ref<string>();
const detail = ref<string>();
const issueDate = ref<number>(new Date().getFullYear());
const issueDate2 = ref<Date>(new Date());
const refCommandNo = ref<string>();
const refCommandDate = ref<Date | null>(new Date());
const myForm = ref<any>(); //form data input
const edit = ref<boolean>(false); //เช็คการกดปุ่มแก้ไขใน dialog
const modal = ref<boolean>(false); //modal add detail
const modalEdit = ref<boolean>(false); //modal ที่แสดงใช้สำหรับแก้ไขหรือไม่
const rawItem = ref<RequestItemsObject>(); //ข้อมูลเดิมที่เลือกใน row นั้น
const rowIndex = ref<number>(0); //indexข้อมูลเดิมที่เลือกใน row นั้น
const previous = ref<boolean>(); //แสดงปุ่มดูข้อมูลก่อนหน้า
const next = ref<boolean>(); //แสดงปุ่มดูข้อมูลต่อไป
const editRow = ref<boolean>(false); //เช็คมีการแก้ไขข้อมูล
const rowsHistory = ref<any[]>([]); //select data history
const tittleHistory = ref<string>("ประวัติแก้ไขประกาศเกียรติคุณ"); //
const filterHistory = ref<string>(""); //search data table history
const modalHistory = ref<boolean>(false); //modal ประวัติการแก้ไขข้อมูล
const checkValidate = ref<boolean>(false); //validate data ผ่านหรือไม่
const profileId = ref<string>(
  route.params.id ? route.params.id.toString() : ""
);
const rows = ref<any[]>([]);
const filter = ref<string>(""); //search data table
const visibleColumns = ref<String[]>([]);
profileData.coined.columns.length == 0
  ? (visibleColumns.value = [
      "issuer",
      "detail",
      "issueDate",
      "refCommandNo",
      "refCommandDate",
    ])
  : (visibleColumns.value = profileData.coined.columns);
const columns = ref<QTableProps["columns"]>([
  {
    name: "issueDate",
    align: "left",
    label: "วันที่ได้รับ",
    sortable: true,
    field: "issueDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "issuer",
    align: "left",
    label: "ผู้มีอำนาจลงนาม",
    sortable: true,
    field: "issuer",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "refCommandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandDate",
    align: "left",
    label: "เอกสารอ้างอิง (ลงวันที่)",
    sortable: true,
    field: "refCommandDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const columnsHistory = ref<QTableProps["columns"]>([
  {
    name: "issueDate",
    align: "left",
    label: "วันที่ได้รับ",
    sortable: true,
    field: "issueDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "issuer",
    align: "left",
    label: "ผู้มีอำนาจลงนาม",
    sortable: true,
    field: "issuer",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "refCommandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandDate",
    align: "left",
    label: "เอกสารอ้างอิง (ลงวันที่)",
    sortable: true,
    field: "refCommandDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "createdFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "createdFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const visibleColumnsHistory = ref<String[]>([
  "issuer",
  "detail",
  "issueDate",
  "refCommandNo",
  "refCommandDate",
  "createdFullName",
  "createdAt",
]);

watch(visibleColumns, async (count: String[], prevCount: String[]) => {
  await changeProfileColumns("coined", count);
});

const inputDateRef = ref<string>("");
const inputYear = ref<string>("");
const inputDate = ref<string>("");
const dayCheckedRef = ref<boolean>(false);
const dayChecked = ref<boolean>(false);
const yearChecked = ref<boolean>(false);

watch(
  () => inputDate.value,
  (value: string) => {
    if (value.length === 10) {
      const dateVal = convertDate(value);
      if (dateVal.isValid) {
        dayChecked.value = false;
        issueDate2.value = new Date(dateVal.value);
      } else {
        dayChecked.value = true;
        inputDate.value = "";
      }
    }
  }
);

watch(
  () => inputYear.value,
  (value: string) => {
    if (value.length === 4) {
      yearChecked.value = false;
      issueDate.value = parseInt(value) - 543;
    }
  }
);

watch(
  () => inputDateRef.value,
  (value: string) => {
    if (value.length === 10) {
      const dateVal = convertDate(value);
      if (dateVal.isValid) {
        dayCheckedRef.value = false;
        refCommandDate.value = new Date(dateVal.value);
      } else {
        dayCheckedRef.value = true;
        inputDateRef.value = "";
      }
    } else if (value.length === 0) {
      dayCheckedRef.value = false;
      refCommandDate.value = null;
    }
  }
);

onMounted(async () => {
  await fetchData();
});

const fetchData = async () => {
  if (profileId.value) {
    showLoader();
    await http
      .get(config.API.profileHonorId(profileId.value))
      .then((res) => {
        let data = res.data.result;
        console.log(data);
        rows.value = [];
        data.map((e: ResponseObject) => {
          rows.value.push({
            id: e.id,
            issuer: e.issuer,
            detail: e.detail,
            isDate: e.isDate,
            issueDate: e.issueDate ? new Date(e.issueDate).getFullYear() : null,
            issueDate2: new Date(e.issueDate),
            refCommandNo: e.refCommandNo,
            refCommandDate: e.refCommandDate,
            createdAt: new Date(e.createdAt),
            createdFullName: e.createdFullName,
          });
        });
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        store.isLoad++;
      });
  }
};

/**
 * กดดูข้อมูลก่อนหน้า
 */
const clickPrevious = async () => {
  edit.value = false;
  rowIndex.value -= 1;
  await getData();
  await checkRowPage();
};

/**
 * กดดูข้อมูลต่อไป
 */
const clickNext = async () => {
  edit.value = false;
  rowIndex.value += 1;
  await getData();
  await checkRowPage();
};

/**
 * กดดูข้อมูลต่อไป
 */
const getData = () => {
  const row = rows.value[rowIndex.value];
  console.log(row);
  issuer.value = row.issuer;
  detail.value = row.detail;
  isDate.value = row.isDate.toString();
  issueDate.value = row.issueDate;
  issueDate2.value = row.issueDate2;
  refCommandNo.value = row.refCommandNo;
  refCommandDate.value = row.refCommandDate;
  id.value = row.id;
};

/**
 * เช็คปุ่มดูข้อมูล ย้อน กับ ต่อไป ว่าต้องแสดงไหม
 */
const checkRowPage = () => {
  editRow.value = false;
  next.value = true;
  previous.value = true;
  if (rowIndex.value + 1 >= rows.value.length) {
    next.value = false;
  }
  if (rowIndex.value - 1 < 0) {
    previous.value = false;
  }
};

/**
 * กดปุ่มแก้ไขใน dialog
 */
const clickEdit = () => {
  editRow.value = false;
  next.value = false;
  previous.value = false;
};

/**
 * กดปุ่มเพิ่มด้านบน table
 */
const clickAdd = async () => {
  editRow.value = false;
  await addData();
};

/**
 * กดบันทึกใน dialog
 */
const clickSave = async () => {
  dayChecked.value = validateTime(inputDate.value);
  dayCheckedRef.value = validateTime(inputDateRef.value);
  if (dayCheckedRef.value || dayChecked.value) return;

  myForm.value.validate().then(async (result: boolean) => {
    if (result) {
      if (modalEdit.value) {
        await editData();
      } else {
        if (inputDate.value === "") dayChecked.value = true;
        await saveData();
      }
    }
  });
};

/**
 * บันทึกเพิ่มข้อมูล
 */
const saveData = async () => {
  if (profileId.value) {
    showLoader();
    await http
      .post(config.API.profileHonorId(profileId.value), {
        id: id.value,
        issuer: issuer.value,
        detail: detail.value,
        isDate: isDate.value == "true" ? true : false,
        issueDate:
          isDate.value == "true"
            ? dateToISO(issueDate2.value)
            : new Date(`${issueDate.value}-01-01`),
        refCommandNo: refCommandNo.value,
        refCommandDate:
          refCommandDate.value == null ? null : dateToISO(refCommandDate.value),
      })
      .then((res) => {
        success($q, "บันทึกข้อมูลสำเร็จ");
        modal.value = false;
        inputYear.value = "";
        inputDateRef.value = "";
        inputDate.value = "";
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(async () => {
        await fetchData();
      });
  }
};

/**
 * บันทึกแก้ไขข้อมูล
 */
const editData = async () => {
  showLoader();
  await http
    .put(config.API.profileHonorId(id.value), {
      id: id.value,
      issuer: issuer.value,
      detail: detail.value,
      isDate: isDate.value == "true" ? true : false,
      issueDate:
        isDate.value == "true"
          ? dateToISO(issueDate2.value)
          : new Date(`${issueDate.value}-01-01`),
      refCommandNo: refCommandNo.value,
      refCommandDate:
        refCommandDate.value == null ? null : dateToISO(refCommandDate.value),
    })
    .then((res) => {
      success($q, "บันทึกข้อมูลสำเร็จ");
      modal.value = false;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      await fetchData();
    });
};

/**
 * ลบลบข้อมูล
 */
const clickDelete = async () => {
  $q.dialog({
    title: `ลบข้อมูล`,
    message: `ต้องการทำการลบข้อมูลนี้ใช่หรือไม่?`,
    cancel: "ยกเลิก",
    ok: "ยืนยัน",
    persistent: true,
  })
    .onOk(async () => {
      showLoader();
      await http
        .delete(config.API.profileHonorId(id.value))
        .then((res) => {
          success($q, "ลบข้อมูลสำเร็จ");
          modal.value = false;
        })
        .catch((e) => {
          messageError($q, e);
        })
        .finally(async () => {
          await fetchData();
        });
    })
    .onCancel(async () => {
      await fetchData();
    });
};

/**
 * กดปิด dialog
 */
const clickClose = async () => {
  if (editRow.value == true) {
    $q.dialog({
      title: `ข้อมูลมีการแก้ไข`,
      message: `ยืนยันที่จะปิดโดยไม่บันทึกใช่หรือไม่?`,
      cancel: "ยกเลิก",
      ok: "ยืนยัน",
      persistent: true,
    }).onOk(async () => {
      modal.value = false;
      next.value = false;
      previous.value = false;
    });
  } else {
    modal.value = false;
    next.value = false;
    previous.value = false;
    dayChecked.value = false;
    dayCheckedRef.value = false;
  }
};

/**
 * กดเลือกข้อมูลที่จะแก้ไข
 * @param props ค่า props ใน row ที่เลือก
 */
const selectData = async (props: any) => {
  modalEdit.value = true;
  modal.value = true;
  edit.value = false;
  rawItem.value = props.row;
  rowIndex.value = props.rowIndex;
  issuer.value = props.row.issuer;
  detail.value = props.row.detail;
  issueDate.value = props.row.issueDate;
  isDate.value = props.row.isDate.toString();
  issueDate2.value = props.row.issueDate2;
  refCommandNo.value = props.row.refCommandNo;
  refCommandDate.value =
    props.row.refCommandDate == "-" ? null : props.row.refCommandDate;
  id.value = props.row.id;
  inputYear.value = props.row.issueDate + 543;
  inputDate.value = convertDateDisplay(props.row.issueDate2);
  inputDateRef.value = props.row.refCommandDate
    ? convertDateDisplay(props.row.refCommandDate)
    : "";
  await checkRowPage();
};

/**
 * กดปุ่มเพิ่มบน table
 */
const addData = () => {
  modalEdit.value = false;
  inputDate.value = "";
  inputYear.value = "";
  inputDateRef.value = "";
  modal.value = true;
  edit.value = true;
  issuer.value = "";
  detail.value = "";
  issueDate.value = new Date().getFullYear();
  issueDate2.value = new Date();
  refCommandNo.value = "";
  refCommandDate.value = null;
};

/**
 * ฟังก์ชันปุ่มยกเลิกการแก้ไขข้อมูล
 */
const clickCancel = async () => {
  if (editRow.value == true) {
    $q.dialog({
      title: `ข้อมูลมีการแก้ไข`,
      message: `ยืนยันยกเลิกการแก้ไขใช่หรือไม่?`,
      cancel: "ยกเลิก",
      ok: "ยืนยัน",
      persistent: true,
    }).onOk(async () => {
      edit.value = false;
      await checkRowPage();
      await getData();
    });
  } else {
    edit.value = false;
    await checkRowPage();
  }
};

/**
 * เช็คว่ามีการแก้ไขข้อมูล
 */
const clickEditRow = () => {
  editRow.value = true;
};

/**
 * ฟังชั้นดูข้อมูลประวัติแก้ไขข้อมูลที่เลือก
 * @param row ข้อมูล row ที่ดูประวัติการแก้ไข
 */
const clickHistory = async (row: RequestItemsObject) => {
  tittleHistory.value =
    props.profileType == "employee"
      ? "ประวัติแก้ไขประกาศลูกจ้างดีเด่น"
      : "ประวัติแก้ไขประกาศเกียรติคุณ";
  modalHistory.value = true;
  filterHistory.value = "";
  showLoader();
  await http
    .get(config.API.profileHonorHisId(row.id))
    .then((res) => {
      let data = res.data.result;
      rowsHistory.value = [];
      data.map((e: any) => {
        rowsHistory.value.push({
          id: e.id,
          issuer: e.issuer,
          detail: e.detail,
          issueDate: new Date(e.issueDate).getFullYear(),
          issueDate2: new Date(e.issueDate),
          refCommandNo: e.refCommandNo,
          refCommandDate:
            e.refCommandDate == null ? null : new Date(e.refCommandDate),
          createdAt: new Date(e.createdAt),
          createdFullName: e.createdFullName,
        });
      });
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};

/**
 * validate input ใน dialog
 */
const validateData = async () => {
  checkValidate.value = true;
  await myForm.value.validate().then((result: boolean) => {
    if (result == false) {
      checkValidate.value = false;
    }
  });
};

/**
 * class จัดรูปแบบแสดงระหว่างข้อมูลที่แก้ไขหรือแสดงเฉยๆ
 * @param val ข้อมูล input สำหรับแก้ไขหรือไม่
 */
const getClass = (val: boolean) => {
  return {
    "full-width inputgreen cursor-pointer": val,
    "full-width cursor-pointer": !val,
  };
};
const resetFilter = () => {};
</script>
<style lang="scss">
.modalfix {
  position: fixed !important;
}
</style>
